//CURRENT
#version 440
layout(binding = 0) buffer dcA1 { float A1 [  ]; };
layout(binding = 1) buffer dcA2 { float A2 [  ]; };
layout(binding = 2) buffer dcB1 { float B1 [  ]; };
layout(binding = 3) buffer dcB2 { float B2 [  ]; };
layout(rgba8,binding=4) uniform writeonly image2D img;
layout(local_size_x = 20, local_size_y = 20, local_size_z = 1) in;
layout(rgba8, binding = 6) uniform image2D imgflp;
layout(rgba8, binding = 7) uniform image2D g1;

uniform int NX;
uniform int NY;
//#define W NX
//#define H NY

uniform float DA;
uniform float DB;
uniform float f;
uniform float k;
uniform float dt;
uniform float t;

//https://iquilezles.org/articles/smin/
float opSmoothUnion(float d1, float d2, float k)
{
    float h = max(k - abs(d1 - d2), 0.0);
    return min(d1, d2) - h * h * 0.25 / k;
}
// root
float smin(float a, float b, float k)
{
    k *= 2.0;
    float x = b - a;
    return 0.5 * (a + b - sqrt(x * x + k * k));
}

void main()
{
    vec4 col2 = imageLoad(imgflp, ivec2(gl_GlobalInvocationID.xy));       // pixel from image
    vec4 colg = imageLoad(g1, ivec2(gl_GlobalInvocationID.xy));       // pixel from image


    int i = int(gl_GlobalInvocationID.x);
    int j = int(gl_GlobalInvocationID.y);

    int idx = i + j * NX;

    float mk = k;
    float mf = f;
    //if (t > 110 && t < 166)
    /*  if (t > 110 && t < 150)
          //if(t>67.4 && t <166)
      if ((i - NX / 2) * (i - NX / 2) + (j - NY / 2) * (j - NY / 2) > (NX / 6) * (NX / 6))
      {
          //vec4 col = vec4(vec3(0.0), 1.0);
          //imageStore(img, ivec2(gl_GlobalInvocationID.xy), col);
          //return;
          //k = 0.0625;	f = 0.035;  // spots
          mk = 0.06; mf = 0.035;    // stripes		// 1
                              //mk = 0.0475; mf = 0.0118; // spiral waves
      }*/


    // transform
    if (t > 110 && t < 180)
    {
        //float h = (t - 150) / (180.0 - 150);      // 0-1
        //float h = (t - 140) / (170.0 - 140);      // 0-1
        float h = (t - 150) / (175.0 - 150);      // 0-1
        float h01;

        if (h > 1) h = 1;
        if (h < 0) h = 0;
        //a=1 -pow(1 - a, 4);
        //h = sqrt(1 - pow(h - 1, 2));
        //h = 1 - pow(1 - h, 4);
        //return x < 0.5 ? 8 * x * x * x * x : 1 - Math.pow(-2 * x + 2, 4) / 2;       // https://easings.net/#easeInOutQuart
        /*if (h < 0.5)
            h = 8 * h * h * h * h;
        else
            h= 1 - pow(-2 * h + 2, 4) / 2;*/

        h01 = h;
        float hs = 0;// -h01 * NX / 32;
        h = h01 * NX / 5;
        float d1 = (i - NX / 2 - h) * (i - NX / 2 - h) + (j - NY / 2) * (j - NY / 2) - (NX / 8.0 - hs) * (NX / 8.0 - hs);
        float d2 = (i - NX / 2 + h) * (i - NX / 2 + h) + (j - NY / 2) * (j - NY / 2) - (NX / 8.0 - hs) * (NX / 8.0 - hs);

        //float d = min(d1, d2);
        float d = smin(d1, d2, NX * 24.0);//
                                          //DCALC = d;

        /* if(t<180.0)
         if (d > -5000.0 && d<0)
         {
             mk = 0.0475; mf = 0.0118;

         }*/

        //if(t>170)
        /* if (d < 0.0)//-h01*NX/32)
         {
             mk = 0.06; mf = 0.035;
             //vec4 col = vec4(vec3(1.0), 1.0);
             //imageStore(img, ivec2(gl_GlobalInvocationID.xy), col);
             //return;
         }
        */

        if (d > 0.2)
        {
            mk = 0.06; mf = 0.035;
            //vec4 col = vec4(vec3(1.0), 1.0);
            //imageStore(img, ivec2(gl_GlobalInvocationID.xy), col);
            //return;
        }


    }

    /*if (t > 200 && t < 200.2)
    {
        if (col2.r < 0.5)
        {
            mk = 0.0475; mf = 0.0118; // spiral waves
        }
    }*/

    //if (t > 202 && t < 202.4) if (colg.r < 0.5) { mk = 0.0475; mf = 0.0118; } // spiral waves

    if (t > 195 && t < 255)
        if (colg.r < 0.5)
        {
            mk = 0.0475; mf = 0.0118;   //// spiral waves/           // 

            // change to mk = 0.06; mf = 0.035;      // stripes		// 1
            // for FLOPPY
            //239.199127
            if (t > 235.698914 && t < 255.299377)
            {
                mk = 0.06; mf = 0.035;
            }

        }


    if (t > 260)
        if (colg.r > 0.5)
        {
            mk = 0.0475; mf = 0.0118;
        } // spiral waves/





    //	float dt = 1.0;
    int idx1, idx2, idx3, idx4, idx5, idx6, idx7, idx8;
    int ip, jp, im, jm;

    //ip = per(i+1, NX);		// periodicity and neighbours
    //im = per(i-1, NX);
    //jp = per(j+1, NY);
    //jm = per(j-1, NY);

    ip = (i + 1) % NX;
    jp = (j + 1) % NY;
    im = (i - 1 + NX) % NX;
    jm = (j - 1 + NY) % NY;

    //idx = i+W*j;			// neighbours
    idx1 = ip + NX * (jp);
    idx2 = ip + NX * (j);       // i+1,j
    idx3 = ip + NX * (jm);
    idx4 = i + NX * (jm);       // i,j-1
    idx5 = im + NX * (jm);
    idx6 = im + NX * (j);       // i-1, j
    idx7 = im + NX * (jp);
    idx8 = i + NX * (jp);        // i, j+1

    // laplasians
    float laplA = -1.0 * A1[idx] + .2 * (A1[idx6] + A1[idx2] + A1[idx4] + A1[idx8]) + 0.05 * (A1[idx1] + A1[idx3] + A1[idx5] + A1[idx7]);
    float laplB = -1.0 * B1[idx] + .2 * (B1[idx6] + B1[idx2] + B1[idx4] + B1[idx8]) + 0.05 * (B1[idx1] + B1[idx3] + B1[idx5] + B1[idx7]);

    // Gray Scott model
    A2[idx] = A1[idx] + (DA * laplA - A1[idx] * B1[idx] * B1[idx] + mf * (1 - A1[idx])) * dt;
    B2[idx] = B1[idx] + (DB * laplB + A1[idx] * B1[idx] * B1[idx] - (mk + mf) * B1[idx]) * dt;


    // visualization
    float a = A2[idx];
    float b = B2[idx];
    //vec4 col = color(0.75 * a+0.2);///+1.062*b);//b*0.8+a*1.3);
    //vec4 col = color(a*2.0);//b*0.8+a*1.3);
    //*if (a > 0.51)
    /*col = vec4(0, 0, 0,1);
else
	col = vec4(1, 1, 1,1);*/

    /*float g1 = 1.0 - smoothstep(0.48, 0.62, a);
    float g2 = smoothstep(0.62, 0.48, a);
    vec4 col = vec4(vec3(g2), 1.0);*/
    //float g1 = 1.0 - smoothstep(0.48, 0.62, a);


    //////////////////////float g2 = smoothstep(0.65, 0.40, a);

    float g2 = smoothstep(0.75, 0.30, a);

    vec4 col = vec4(vec3(g2), 1.0);

    //imageStore(img, ivec2(gl_GlobalInvocationID.xy + vec2(t, 0)), col);
    //imageStore(img, gl_GlobalInvocationID.xy + vec2(t, 0), col);

    // RED
    /*if (t > 110 && t < 150)      //smoothlife
    {
        //if(t>67.4 && t <166)
        if ((i - NX / 2) * (i - NX / 2) + (j - NY / 2) * (j - NY / 2) < (NX / 6 - 10) * (NX / 6 - 3))
        {
            col.g /= 5.0;
            col.b /= 5.0;
        }
    }*/

    if (t > 110 && t < 180)
    {
        //float h = (t - 150) / (180.0 - 150);      // 0-1
        //float h = (t - 140) / (170.0 - 140);      // 0-1
        float h = (t - 150) / (175.0 - 150);      // 0-1
        float h01;

        if (h > 1) h = 1;
        if (h < 0) h = 0;
        //a=1 -pow(1 - a, 4);
        //h = sqrt(1 - pow(h - 1, 2));
        //h = 1 - pow(1 - h, 4);
        //return x < 0.5 ? 8 * x * x * x * x : 1 - Math.pow(-2 * x + 2, 4) / 2;       // https://easings.net/#easeInOutQuart
        /*if (h < 0.5)
            h = 8 * h * h * h * h;
        else
            h= 1 - pow(-2 * h + 2, 4) / 2;*/

        h01 = h;
        //float hs = 1;// h01 * NX / 32;
        float hs = 0;// -h01 * NX / 32;
        h = h01 * NX / 5;
        float d1 = (i - NX / 2 - h) * (i - NX / 2 - h) + (j - NY / 2) * (j - NY / 2) - (NX / 8.0 - hs) * (NX / 8.0 - hs);
        float d2 = (i - NX / 2 + h) * (i - NX / 2 + h) + (j - NY / 2) * (j - NY / 2) - (NX / 8.0 - hs) * (NX / 8.0 - hs);

        //float d = min(d1, d2);
        float d = smin(d1, d2, NX * 24.0);//

        if (t < 180.0)
            //if (d < -5000.0)
            if (d < -100.0)
            {
                col.g /= 5.0;
                col.b /= 5.0;
            }
    }

    // THE END
    if (t > 260)
    {
        if (colg.r > 0.5)
        {
            col.g /= 5.0;
            col.b /= 5.0;
        }
    }

    // FLOPPY MITOSIS
    //if (t > 195 && t < 255 && i>NX-NX/4)
    /*if (colg.r < 0.5)
    {
        if (t > 235.698914 && t < 255.299377 && i > 411 && i < 648)
        {

            col.g /= 5.0;
            col.b /= 5.0;
        }
    }*/

    float alpha = 0.05;

    if (colg.r < 0.5)
    {
        /*  if (t > 198.929352 && t<252+10)

   //       if (t > 198.929352 - alpha && t < 199.929352 + 1.0 + 0.2 - alpha
     //     || t > 223.314484 - alpha && t < 223.314484 + 1.0 + 0.2 - alpha)

          //if(t>198 && t<252)//t<223)
          {
              //if (t > 235.698914 && t < 255.299377)
              if (t > 237.698914 && t < 245.299377)
              {// floppy

                  float h = (t - 239.698914) / 2.0;
                  if (h > 1) h = 1;

                  if (i > 411 && i < 648)
                  //if (i > 655 && i < 848)
                  {
                      //col.g /= 5.0;
                      //col.b /= 5.0;
                      //col.r *= (1 - h);
                      col.r = col.r * (1 - h) + 1.0 * h;
                      col.g = col.g * (1 - h) + 0.0 * h;
                      col.b = col.b * (1 - h) + 0.0 * h;
                  }
                  else
                  {

                      col.r *= (1 - h);
                      col.g *= (1 - h);
                      col.b *= (1 - h);
                  }


              }
        */
        //float SBSTART = 242.5;
        if (t > 237.698914 && t < 245.299377)
        {// floppy

            float h = (t - 241.0) / 1.0;
            if (h > 1) h = 1;
            if (h < 0) h = 0;
            {
                //col.g /= 5.0;
                //col.b /= 5.0;
                //col.r *= (1 - h);
                col.r = col.r * (1 - h) + 1.0 * h;
                col.g = col.g * (1 - h) + 0.0 * h;
                col.b = col.b * (1 - h) + 0.0 * h;
            }

        }

        if (t < 235.698914)//240.698914)
        {

            col.g /= 5.0;
            col.b /= 5.0;
        }
    }


    /*alpha += 0.7;

    if (t > 201.262665 - alpha && t < 201.262665 + 0.2 - alpha ||
    t > 202.629700 - alpha && t < 202.629700 + 0.2 - alpha ||
    t > 203.996246 - alpha && t < 203.996246 + 0.2 - alpha ||
    t > 205.346344 - alpha && t < 205.346344 + 0.2 - alpha ||
    t > 206.729736 - alpha && t < 206.729736 + 0.2 - alpha ||
    t > 208.163269 - alpha && t < 208.163269 + 0.2 - alpha ||
    t > 209.496582 - alpha && t < 209.496582 + 0.2 - alpha ||
    t > 210.896698 - alpha && t < 210.896698 + 0.2 - alpha ||
    t > 212.296906 - alpha && t < 212.296906 + 0.2 - alpha ||
    t > 213.630493 - alpha && t < 213.630493 + 0.2 - alpha ||
    t > 215.030426 - alpha && t < 215.030426 + 0.2 - alpha ||
    t > 216.397186 - alpha && t < 216.397186 + 0.2 - alpha ||
    t > 217.797394 - alpha && t < 217.797394 + 0.2 - alpha ||
    t > 219.147552 - alpha && t < 219.147552 + 0.2 - alpha ||
    t > 220.547668 - alpha && t < 220.547668 + 0.2 - alpha ||
    t > 221.914246 - alpha && t < 221.914246 + 0.2 - alpha)
    {

        col.g /= 5.0;
        col.b /= 5.0;

    }*/

    //}


    if (t > 51.5 && t < 67.4)
    {
        // if (i > 348 && i < 348 + 163 && j > 302 && j < 302 + 146)
        if (j > NY / 2 && j < NY / 2 + NY / 64 && i > NX / 2 && i < NX / 2 + NX / 64)
        {
            col.g /= 5.0;
            col.b /= 5.0;
        }
    }

    //88.75

    if (t > 67.4 && t < 131.5)
    {

        // if (t < 109.0)
        {
            int offsx = NX / 64 - NX / 148;
            int offsy = -NY / 48;
            // if (i > 348 && i < 348 + 163 && j > 302 && j < 302 + 146)
            if (j > NY / 2 + offsy - 2 && j < NY / 2 + NY / 64 + offsy && i > NX / 2 + offsx && i < NX / 2 + NX / 64 + offsx)
            {
                //col.r = 0.0;
                //col.g = 0.0;
                //col.b = 0.0;
                col.g /= 5.0;
                col.b /= 5.0;
            }
        }
    }

    //if (colg.r > 0.5)
    /*if (t > 237.698914 && t < 245.299377)
    {// ~floppy dissapeearance

        float h = (t - 239.698914) / 2.0;
        if (h > 1) h = 1;
        col.r *= (1 - h);
        col.g *= (1 - h);
        col.b *= (1 - h);
    }*/
    if (t > 237.698914 && t < 242.5)
    { 
        float hdis = (t - 242.0) / 0.5;
        if (hdis > 1) hdis = 1;
        if (hdis < 0) hdis = 0;

       col.r *= (1 - hdis);
        col.g *= (1 - hdis);
        col.b *= (1 - hdis);
    }

    imageStore(img,ivec2(gl_GlobalInvocationID.xy),col);
}

